﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Runtime = Microsoft.SqlServer.Dts.Runtime;

namespace SSISFromCode
{

    internal class DelimitedGenerator : FlatFileGenerator, IRequireSourceConnection
    {

        void IRequireSourceConnection.ConfigureSourceConnection()
        {
            base.ConfigureSourceConnection();
            _connectionSource.Properties[FLAT_FILE_PROPERTY_NAMES.FORMAT].SetValue( _connectionSource, FORMAT.DELIMITED );
            _connectionSource.Properties[FLAT_FILE_PROPERTY_NAMES.QUALIFIER].SetValue( _connectionSource, ((DelimitedImportOptions)_options).Qualifier );  //MISC.QUOTE_QUALIFIER
        }

    }

}
